require 'thor'
require 'but'

module But

  class SubCommandBase < Thor
    def self.banner(command, namespace = nil, subcommand = false)
      "#{basename} #{subcommand_prefix} #{command.usage}"
    end

    def self.subcommand_prefix
      self.name.gsub(%r{.*::}, '').gsub(%r{^[A-Z]}) { |match| match[0].downcase }.gsub(%r{[A-Z]}) { |match| "-#{match[0].downcase}" }
    end
  end


  class How < Thor
    class_option :measure, :type => :boolean, :default => false
    class_option :gc, :type => :boolean, :default => true
    class_option :profile, :aliases => '-p', required: false, desc: 'create a ruby prof profile; Possible values: MEMORY, ALLOCATIONS, WALL_TIME, PROCESS_TIME'

    desc "messy am I?", "How messed up is your home?"
    def messy(*words)
      if options[:measure]
        measure(options) do
          say But::HomeKeeper.judge
        end
      elsif options[:profile]
        profile(options) do
          say But::HomeKeeper.judge
        end
      else
        say But::HomeKeeper.judge
      end
    end
  end

  class CLI < Thor

    desc "how", "asks something"
    subcommand "how", How
    #def how_messy_am_I?(*words)
    #  if words.any? {|w| w =~ /mess/}
    #    puts But::HomeKeeper.judge
    #  end
    #end
  end

end
